/***************************************************************************
* Pour mesurer la pollution de l'air et aerer lorsqu'un certain niveau est *
*atteind. Evaluation de la teneur en CO2 (Dioxyde de carbone) et en TVOC   *
*(Total volatil organic composents)avec une sonde SGP30 et affichage sur un*
* écrant TFT de 1,8" géré par un ATMEGA328 . pour en savoir plus, vsitons  *
*le site https://amazing-vacuum- tubes.com   B.LECLERC 02/24               *
***************************************************************************/

#include "SparkFun_SGP30_Arduino_Library.h" // Bibliothèque du détecteur
#include <Wire.h>  // I2C pour le detecteur
#include <SPI.h> // Communication SPI pour l'écran
#include <Adafruit_ST7735.h> // Biblothèque de l'ecran Adafruit ST7735

// Définition des pinuches de l'écran
#define TFT_PIN_CS   6  // Pin Chip select CS   
#define TFT_PIN_DC   9  // Pin  A0
#define TFT_PIN_RST  8  // Reset-Pin

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_PIN_CS, TFT_PIN_DC, TFT_PIN_RST);  // Initialise l'afficheur
 
SGP30 mySensor; //initialise le capteur le SGP30 

// Declaration des entrees et des variables 
int Button = A3; //Bouton d'allumage d'écran
int led = 5;  // Rétro-éclairage
long t1, t2; // Variables d'interval de mesure
int i; // Boucle de tempo

void setup() {
  pinMode(Button,INPUT_PULLUP); //Entrée du bouton avec "tirage à 1"
  pinMode(led,OUTPUT); // Mise en sortie  du DDR pour Retro-eclarage 
  analogWrite(led, 255); // Allume le Retro-eclarage
  
  tft.initR(INITR_BLACKTAB);   // Initialisation ST7735-Chip

  Wire.begin();
  Wire.setClock(400000); // Vitesse d'horloge I2C à 400kHz
  //Initialize sensor
  if (mySensor.begin() == false) {
    while (1);
  }
  //Initialisation du capteur pour lire la qualité de l'air
  mySensor.initAirQuality();
  t1 = millis();

  //Ecriture dde la page d'accueil 
  tft.fillScreen(ST7735_BLACK); // effacement afficheur
tft.setTextSize(1);// Réglage de la taille des caracteres
  tft.setTextColor(ST7735_GREEN);// Reglage couleur de text
    tft.setCursor(20,4);// Position du texte
      tft.print("https://amazing-");// Ecriture du texte première ligne
    tft.setCursor(20,15);// Position du nouveau texte seconde ligne
  tft.print("vacuum-tubes.com");// Ecriture du texte seconde ligne 
  delay(2000);
}
 
void loop() {
  t2 = millis();
  if ( t2 >= t1 + 2000) // Intervales de lecture à 1 seconde
  { t1 = t2;
    i++; // Incrémentation boucle d'allumage automatique 
    mySensor.measureAirQuality(); //mesure des niveaux de CO2 et TVOC 

    //Ecriture du titre et de la valeur de CO2
tft.fillScreen(ST7735_BLACK); // effacement afficheur
 tft.setTextSize(2);  // Réglage de la taille des caracteres
    // couleur du texte suivant la teneur
    if (mySensor.CO2 < 410) { tft.setTextColor ( ST7735_BLUE);}
    if ((mySensor.CO2 > 410) and (mySensor.CO2 < 600)) { tft.setTextColor ( ST7735_GREEN);}
    if ((mySensor.CO2 > 600) and (mySensor.CO2 < 1000)) { tft.setTextColor ( ST7735_YELLOW);}
    if (mySensor.CO2 > 1000) { tft.setTextColor ( ST7735_RED); }
   tft.setCursor(4,4);  // Définir la position du texte
    tft.print("   CO2: ");  // texte ecrit
     tft.setCursor(20,30);  // Définir la position du texte
    tft.print(mySensor.CO2);  // texte ecrit
   tft.print(" ppm");  // texte ecrit

    // couleur du texte suivant la teneur
    if (mySensor.TVOC < 10) { tft.setTextColor (ST7735_BLUE);}
    if ((mySensor.TVOC >10) and (mySensor.TVOC < 600)) {  tft.setTextColor (ST7735_GREEN);}
    if ((mySensor.TVOC > 600) and (mySensor.TVOC < 1000)) {  tft.setTextColor (ST7735_YELLOW);}
    if (mySensor.TVOC > 1000) { tft.setTextColor (ST7735_RED);}
 tft.setCursor(4,60);  // Définir la position du texte
tft.print("Comp.Organ");  // texte ecrit
 tft.setCursor(4,80);  // Définir la position du texte
  tft.print("Volat.Tot:");  // texte ecrit
   tft.setCursor(20,105);  // Définir la position du texte
  tft.print(mySensor.TVOC);  // texte ecrit
 tft.print(" ppb");  // texte ecrit
     }
// Blocage de l'afficheur allumé sur les valeurs dangereuses
if (( mySensor.CO2 > 1000) or (mySensor.TVOC > 1000)) {
  analogWrite(led, 255); // Retro-eclarage
   lightOn();
  }
// allumage de l'afficheur si le poussoir est appuyé
  if ((digitalRead (Button)== LOW) or (i > 30)) {
    analogWrite(led, 255); // Retro-eclarage
     delay (5000);
     i = 0;
  }
  analogWrite(led, 7); // Retro-eclarage mise en veille
}

void lightOn() {  // Demande d'aeration jusqu'a POR
  analogWrite(led, 255); // Retro-eclarage allumé
  delay (5000);
   lightOn();  // et on boucle jusqu'à coupure du courant  
  }
